#!/bin/sh -u

#
#	WARNING: Do Not Remove This Section
#
#	$RCSfile: out2golden.sh,v $
#	$Revision: 1.2 $
#	$Date: 2006/10/16 12:59:33 $
#	$Author: zapreevis $
#	
#	MRMC is a model checker for discrete-time and continuous-time Markov reward models.
#	It supports reward extensions of PCTL and CSL (PRCTL and CSRL), and allows for the
#	automated verification of properties concerning long-run and instantaneous rewards
#	as well as cumulative rewards.
#	
#	Copyright (C) The University of Twente, 2004-2006.
#	Authors: Ivan Zapreev
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License
#	as published by the Free Software Foundation; either version 2
#	of the License, or (at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#	Our contacts:
#		Formal Methods and Tools Group, University of Twente,
#		P.O. Box 217, 7500 AE Enschede, The Netherlands,
#		Phone: +31 53 4893767, Fax: +31 53 4893247,
#		E-mail: mrmc@cs.utwente.nl
#
#	Source description: This script runs tests
#

TESTS=`eval cat ${1} | sed -e '/#.*/d'` ; export TESTS

#%%%%%%%%%%%%EXECUTE TESTS%%%%%%%%%%%%%%%
export PATH=.:${PATH}		#Add local directory to the path, otherwise the tests will not run

for test in ${TESTS}
do
	echo "Processing the test: ${test}"
	cd ${test}
	
	#Remove Prism output files first
	rm -f *.prism.log.out
	
	#Process all goldens in the directory
	ls *.out | while read out; do
		TEST_CASE_NAME=`echo ${out} | sed -e 's/.out//'`
		echo "  Processing the test case:"
		echo -n "    ${TEST_CASE_NAME} .........."
		
		#Remove goldens if any
		rm -f ${TEST_CASE_NAME}.golden
		
		#Move out to golden
		mv ${TEST_CASE_NAME}.out ${TEST_CASE_NAME}.golden
		rm -f ${TEST_CASE_NAME}.diff
		
		#Pack new goldens back
		zip ${test}.zip -u ${TEST_CASE_NAME}.golden 2>&1 1> /dev/null
		rm -f ${TEST_CASE_NAME}.golden

		echo "DONE"
	done
	
	cd ..
done
