#
#	WARNING: Do Not Remove This Section
#
#	$RCSfile: average.awk,v $
#	$Revision: 1.2 $
#	$Date: 2006/10/12 11:37:54 $
#	$Author: zapreevis $
#	
#	MRMC is a model checker for discrete-time and continuous-time Markov reward models.
#	It supports reward extensions of PCTL and CSL (PRCTL and CSRL), and allows for the
#	automated verification of properties concerning long-run and instantaneous rewards
#	as well as cumulative rewards.
#	
#	Copyright (C) The University of Twente, 2004-2006.
#	Authors: Ivan Zapreev
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License
#	as published by the Free Software Foundation; either version 2
#	of the License, or (at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#	Our contacts:
#		Formal Methods and Tools Group, University of Twente,
#		P.O. Box 217, 7500 AE Enschede, The Netherlands,
#		Phone: +31 53 4893767, Fax: +31 53 4893247,
#		E-mail: mrmc@cs.utwente.nl
#
#	Source description: This program just reads the column of elements
# 	from the file and computes their average. 
#	@param mult:	 ( -v mult=?). It gives the possibility to computer
#			 the average for -ilump option of MRMC when time
#			 used for lumping is computed separately.
#			 In other words for example for -ilump option of MRMC
#			 time for lumping is computed separately. Thus we have
#			 two times for each run so the multiple should be 2
#	@param out_file: ( -v mult="?") stores the output file name
#			this is required to iutput the given tests
#			statistics into the correct output file in
#			order to collect it for plotting.

BEGIN {
	#print "Computing the average time, given multiple is " mult;
	if ( mult == 0 ) {
		print "\n average.wak: ERROR: The value of parameter mult is 0!"
		exit 1;
	}
	if ( out_file == "" ) {
		print "\n average.wak: ERROR: The value of parameter out_file is undefined!"
		exit 1;
	}
}

{
	i +=1; #Count the total numner of columns
	total +=  $1; #Sum up the column elements
}

END {
	if ( i != 0 && out_file != "" ) {
		print (total/i * mult) >> out_file;
	}else{
		print "\n average.wak: ERROR: the out_file is not set!"
	}
}